﻿using Microsoft.Extensions.Configuration;

namespace SoapEndpoint.Tester;

internal static class Program
{
    public static IConfiguration Configuration;

    private static bool UseSimpleMode
    {
        get
        {
            try
            {
                return bool.Parse(Configuration["SimpleMode"]);
            }
            catch
            {
                return true;
            }
        }
    }

    /// <summary>
    ///     The main entry point for the application.
    /// </summary>
    [STAThread]
    private static void Main()
    {
        // Configuration
        var builder = new ConfigurationBuilder().AddJsonFile("appsettings.json");
        Configuration = builder.Build();

        Application.EnableVisualStyles();
        Application.SetHighDpiMode(HighDpiMode.SystemAware);
        Application.SetCompatibleTextRenderingDefault(false);

        if (UseSimpleMode)
        {
            Application.Run(new SimpleModeForm());
        }
        else
        {
            Application.Run(new Form1());
        }
    }
}