﻿using SoapEndpoint.Service.Flows.BrEnHf.v1.LogbookService;
using SoapEndpoint.Tester.Scenario.Flow.BrEnHf;

namespace SoapEndpoint.Tester.Scenario.Implementations.BrEnHf;

public class BeeindigingScenario : BrEnHfScenarioBase
{
    public override string Name => "Beëindiging scenario";

    protected override async Task ExecuteAsync()
    {
        StartNewScenario("Beeindiging 1");

        await Manager.SHV_FlowAsync(Conversation, null,
            new ShvFlowItem(BerichtType.SHV_Kennisgeving),
            new ShvFlowItem(BerichtType.SHV_Beeindiging));

        StartNewScenario("Beeindiging 2");

        await Manager.SHV_FlowAsync(Conversation, null,
            new ShvFlowItem(BerichtType.SHV_Kennisgeving, BerichtType.SE_KennisgevingAntwoord),
            new ShvFlowItem(BerichtType.SHV_Beeindiging));

        StartNewScenario("Beeindiging 3");

        await Manager.SHV_FlowAsync(Conversation, null,
            new ShvFlowItem(BerichtType.SHV_Saldoverzoek),
            new ShvFlowItem(BerichtType.SHV_Beeindiging));

        StartNewScenario("Beeindiging 4");

        await Manager.SHV_FlowAsync(Conversation, null,
            new ShvFlowItem(BerichtType.SHV_Saldoverzoek, BerichtType.SE_SaldoverzoekAntwoord),
            new ShvFlowItem(BerichtType.SHV_Beeindiging));

        StartNewScenario("Beeindiging 5");

        await Manager.SHV_FlowAsync(Conversation, null,
            new ShvFlowItem(BerichtType.SHV_Saldoverzoek, BerichtType.SE_SaldoverzoekAntwoord),
            new ShvFlowItem(BerichtType.SHV_Betaalvoorstel),
            new ShvFlowItem(BerichtType.SHV_Beeindiging));

        StartNewScenario("Beeindiging 6");

        await Manager.SHV_FlowAsync(Conversation, null,
            new ShvFlowItem(BerichtType.SHV_Saldoverzoek, BerichtType.SE_SaldoverzoekAntwoord),
            new ShvFlowItem(BerichtType.SHV_Betaalvoorstel, BerichtType.SE_BetaalvoorstelAntwoordAkkoord),
            new ShvFlowItem(BerichtType.SHV_Beeindiging));

        StartNewScenario("Beeindiging 7");

        await Manager.SHV_FlowAsync(Conversation, null,
            new ShvFlowItem(BerichtType.SHV_Saldoverzoek, BerichtType.SE_SaldoverzoekAntwoord),
            new ShvFlowItem(BerichtType.SHV_Betaalvoorstel, BerichtType.SE_BetaalvoorstelAntwoordNietAkkoord),
            new ShvFlowItem(BerichtType.SHV_Beeindiging));
    }
}