using SoapEndpoint.Service.Flows.Inventarisatie.v1.LogbookService;
using SoapEndpoint.Service.Proxy.Models.Systeem;
using SoapEndpoint.Service.Proxy.ServiceProxies.Systeem.v2.ErrorMessage;
using SoapEndpoint.Tester.Scenario.Flow.Inventarisatie;

namespace SoapEndpoint.Tester.Scenario.Implementations.Inventarisatie;

public class SeSectorNutsScenario : InventarisatieScenarioBase
{
    public override string Name => "SE sector nuts scenario";

    public override AdresboekOrganisatieModel SeOrganization =>
        Manager.Organizations.SingleOrDefault(p => p.Referentienummer.ToString()
            .Equals(Program.Configuration["SeUtilityCompanyTestOrganizationReference"],
                StringComparison.CurrentCultureIgnoreCase));

    protected override async Task ExecuteAsync()
    {
        StartNewScenario("Happy flow - Saldoverzoek");
        await Manager.SHV_FlowAsync(Conversation, null,
            new ShvFlowItem(BerichtType.SHV_SaldoverzoekNuts, BerichtType.SE_SaldoverzoekAntwoord));


        StartNewScenario("Foutsituatie: saldoverzoek");
        await Manager.SHV_SendIncorrectMessageAsync(Conversation, BerichtType.SHV_Saldoverzoek, null,
            ShvKnooppuntFoutcode.Incorrectberichttypevoorsectorvanontvanger);
    }
}