﻿using SoapEndpoint.Service.Flows.Inventarisatie.v1.LogbookService;
using SoapEndpoint.Service.Proxy.ServiceProxies.Systeem.v2.ErrorMessage;

namespace SoapEndpoint.Tester.Scenario.Implementations.Inventarisatie;

public class VervallenBerichtScenario : InventarisatieScenarioBase
{
    public override string Name => "Vervallen bericht scenario";

    protected override async Task ExecuteAsync()
    {
        await Beeindiging();
    }

    private async Task Beeindiging()
    {
        StartNewScenario("Beeindiging, antwoord op vervallen saldoverzoek");

        var saldoverzoek = await Manager.SHV_SendMessageAsync(Conversation, BerichtType.SHV_Saldoverzoek);

        await Manager.WaitForMessagesToBeProcessed(TimeSpan.FromSeconds(3));

        await Manager.SE_GetAndConfirm(Conversation, BerichtType.SHV_Saldoverzoek);

        await Manager.SHV_SendMessageAsync(Conversation, BerichtType.SHV_Beeindiging);

        await Manager.WaitForMessagesToBeProcessed(TimeSpan.FromSeconds(3));

        await Manager.SE_SendMessageAsync(Conversation, BerichtType.SE_SaldoverzoekAntwoord, saldoverzoek);

        await Manager.WaitForMessagesToBeProcessed(TimeSpan.FromSeconds(3));

        await Manager.SE_GetAndConfirmErrorMessage<ShvKnooppuntFoutbericht, BerichtType, ShvKnooppuntFoutcode>(
            Conversation,
            BerichtType.SYS_FoutBericht);
    }
}