﻿using SoapEndpoint.Service.Proxy.ServiceProxies.Systeem.v1.ErrorMessage;
using SoapEndpoint.Service.Systeem.v1.LogbookService;
using SoapEndpoint.Tester.Scenario.Flow.Schuldbemiddeling;

namespace SoapEndpoint.Tester.Scenario.Implementations.Schuldbemiddeling;

public class CollectiefSchuldregelenWithWrongShvScenario : SchuldbemiddelingScenarioBase
{
    public override string Name => "Collectief schuldregelen met incorrect shv scenario";

    protected override async Task ExecuteAsync()
    {
        StartNewScenario("Incorrect saldo verzoek antwoord standaard akkoord");

        // Send saldoverzoek
        var saldoverzoekResult = await Manager.SHV_RequestReplyAsync(Conversation,
            new ShvFlowItem(Berichttype.SHV_Saldoverzoek));

        // Send SaldoverzoekAntwoordStandaardAkkoord (not allowed)
        await Manager.SE_SendMessageAsync(Conversation, Berichttype.SE_SaldoverzoekAntwoordStandaardAkkoord,
            saldoverzoekResult.RequestMessage);

        // Check that the correct error is returned.
        await Manager.SE_GetAndConfirmErrorMessage<ShvKnooppuntFoutbericht, Berichttype, ShvKnooppuntFoutcode>(
            Conversation,
            Berichttype.SYS_FoutBericht, ShvKnooppuntFoutcode
                .Standaardakkoordisniettoegestaanomdatcollectiefschuldregelennietvoorbeideorganisatieisingeschakeld);
    }
}