﻿using SoapEndpoint.Service.Systeem.v1.LogbookService;

namespace SoapEndpoint.Tester.Scenario.Implementations.Schuldbemiddeling;

public class MassMessageSendScenario : SchuldbemiddelingScenarioBase
{
    public override string Name => "Mass Message Send Scenario";
    private int MessageCount { get; } = 5;
    private TimeSpan Delay { get; } = TimeSpan.FromMilliseconds(1000);
    public override bool DisplayInList { get; }

    protected override async Task ExecuteAsync()
    {
        for (var i = 0; i < MessageCount; i++)
        {
            StartNewScenario($"Message {i}");

            if (i % 2 == 0)
            {
                await Manager.SHV_SendMessageAsync(Conversation, Berichttype.SHV_Saldoverzoek);
            }
            else
            {
                await Manager.SHV_SendMessageAsync(Conversation, Berichttype.SHV_KlantGemeldVoorShv);
            }

            await Task.Delay(Delay);
        }
    }
}